%define section		free

%define	origin		gcj
%define priority	1420
%define	javaver		1.4.2
%define buildver	0
%define gccver		3.4.2

%define name		java-%{javaver}-%{origin}-compat
%define version		%{javaver}.%{buildver}
%define release		11jpp
%define cname           java-%{javaver}-%{origin}

%define	sdklnk		java-%{javaver}-%{origin}
%define	jrelnk		jre-%{javaver}-%{origin}
%define	sdkdir		%{cname}-%{version}
%define	jredir		%{sdkdir}/jre
%define sdkbindir	%{_jvmdir}/%{sdklnk}/bin
%define jrebindir	%{_jvmdir}/%{jrelnk}/bin
%define jvmjardir	%{_jvmjardir}/%{cname}-%{version}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
Summary:	JPackage runtime scripts for GCJ

Group:		Development/Languages
License:	GPL
URL:		http://gcc.gnu.org/java
Source0:        java-1.4.2-gcj-compat-%{version}-%{release}.tar.gz
BuildArch:      noarch
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	jpackage-utils >= 0:1.5, sed
BuildRequires:	gcc-java >= %{gccver}
BuildRequires:	ecj
Requires:	libgcj >= %{gccver}
Provides:	jndi, jdbc-stdext

%description
This package contains shell scripts and symbolic links to simulate a
JPackage Java runtime environment with GCJ.

%package devel
Summary:	JPackage development scripts for GCJ
Group:		Development/Tools
Requires:	/usr/sbin/update-alternatives
Provides:       java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}
Provides:	java-sdk-%{javaver}
Provides:       java-sdk-%{origin} = %{epoch}:%{version}
Provides:	java-sdk = %{javaver}
Provides:       java-%{javaver}-devel
Provides:	java-devel-%{origin} = %{epoch}:%{version}
Provides:       java-devel = %{javaver}
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	ecj

%description devel
This package contains shell scripts and symbolic links to simulate a
JPackage Java development environment with GCJ.

%prep
%setup -q -n java-%{javaver}-gcj-compat-%{version}-%{release}

%build
for tool in Makefile _jpp/bin/* _jpp/jre/bin/*
do
   %{__sed} -i s+%%{_bindir}+%{_bindir}+ $tool
   %{__sed} -i s+%%{_javadir}+%{_javadir}+ $tool
   %{__sed} -i s+%%{_jvmdir}+%{_jvmdir}+ $tool
   %{__sed} -i s+%%{jredir}+%{jredir}+ $tool
   %{__sed} -i s+%%{javaver}+%{javaver}+ $tool
   %{__sed} -i s+%%{gccver}+%{gccver}+ $tool
done
make

%install
rm -rf $RPM_BUILD_ROOT

# main files
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin
# this is needed unless in the future we have something to put in
# _jpp/lib
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/lib
# likewise for _jpp/include
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/include
# install SDK wrapper scripts
pushd _jpp/bin
   for tool in *
   do
      install -m 755 $tool $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin/$tool
   done
popd

install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}

# tools.jar
cp -a tools.jar $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/lib

# extensions handling
install -dm 755 $RPM_BUILD_ROOT%{jvmjardir}

# rest of the jre
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/bin
# this is needed unless in the future we have something to put in
# _jpp/jre/lib
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib
# install JRE wrapper scripts
pushd _jpp/jre/bin
   for tool in *
   do
      install -m 755 $tool $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/bin/$tool
   done
popd

# versionless symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
   ln -s %{jredir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

pushd $RPM_BUILD_ROOT%{_jvmjardir}
   ln -s %{sdkdir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

# generate file lists
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d \
  | sed 's|'$RPM_BUILD_ROOT'|%dir |' >  %{name}-%{version}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f -o -type l \
  | sed 's|'$RPM_BUILD_ROOT'||'      >> %{name}-%{version}-all.files

cat %{name}-%{version}-all.files \
  > %{name}-%{version}.files

find $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin -type f \
  | sed "s|^$RPM_BUILD_ROOT||"      > %{name}-%{version}-sdk-bin.files

pushd $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/include
   ln -s %{_libdir}/gcc-lib/i386-redhat-linux/%{gccver}/include/jni.h jni.h
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives \
  --install %{_bindir}/java java %{jrebindir}/java %{priority} \
  --slave %{_jvmdir}/jre          jre          %{_jvmdir}/%{jrelnk} \
  --slave %{_jvmjardir}/jre       jre_exports  %{_jvmjardir}/%{jrelnk} \
  --slave %{_bindir}/rmiregistry  rmiregistry  %{jrebindir}/rmiregistry

update-alternatives \
  --install %{_jvmdir}/jre-%{origin} \
      jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{origin} \
      jre_%{origin}_exports %{_jvmjardir}/%{jrelnk}

update-alternatives \
  --install %{_jvmdir}/jre-%{javaver} \
      jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{javaver} \
      jre_%{javaver}_exports %{_jvmjardir}/%{jrelnk}

%post devel

update-alternatives \
  --install %{_bindir}/javac javac %{sdkbindir}/javac %{priority} \
  --slave %{_jvmdir}/java     java_sdk          %{_jvmdir}/%{sdklnk} \
  --slave %{_jvmjardir}/java  java_sdk_exports  %{_jvmjardir}/%{sdklnk} \
  --slave %{_bindir}/javadoc  javadoc           %{sdkbindir}/javadoc \
  --slave %{_bindir}/javah    javah             %{sdkbindir}/javah \
  --slave %{_bindir}/jar      jar               %{sdkbindir}/jar \
  --slave %{_bindir}/rmic     rmic              %{sdkbindir}/rmic

update-alternatives \
  --install %{_jvmdir}/java-%{origin} \
      java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{origin} \
      java_sdk_%{origin}_exports %{_jvmjardir}/%{sdklnk}

update-alternatives \
  --install %{_jvmdir}/java-%{javaver} \
      java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{javaver} \
      java_sdk_%{javaver}_exports %{_jvmjardir}/%{sdklnk}

%postun
if [ $1 -eq 0 ] ; then
   update-alternatives --remove java %{jrebindir}/java
   update-alternatives --remove jre_%{origin}  %{_jvmdir}/%{jrelnk}
   update-alternatives --remove jre_%{javaver} %{_jvmdir}/%{jrelnk}
fi

%postun devel
if [ $1 -eq 0 ] ; then
   update-alternatives --remove javac %{sdkbindir}/javac
   update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
   update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
fi

%files -f %{name}-%{version}.files
%defattr(-,root,root,-)
%doc
%dir %{_jvmdir}/%{sdkdir}
%dir %{jvmjardir}
#%{jvmjardir}/*.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
#%{_jvmprivdir}/*

%files devel -f %{name}-%{version}-sdk-bin.files
%defattr(-,root,root)
%doc
%dir %{_jvmdir}/%{sdkdir}/bin
%{_jvmdir}/%{sdkdir}/include
%{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}

%changelog
* Thu Oct  7 2004 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-11jpp
- Don't override $CLASSPATH when we add ecj.jar in javac.

* Wed Oct  6 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-10jpp
- Bump gcc version. (Fix #133898)

* Fri Oct  1 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-9jpp
- Change /usr/lib/jvm directory to java-1.4.2-gcj from
  java-1.4.2-gcj-compat.

* Thu Sep 30 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-8jpp
- Bump release number.

* Thu Sep 30 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-7jpp
- Bump release number.

* Thu Sep 30 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-6jpp
- Bump release number to test Makefile changes.

* Thu Sep 30 2004 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-5jpp
- Make sure ecj.jar is in the classpath if javac is run directly.

* Wed Sep 29 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-3jpp
- Work around dist-CVS tagging bug.

* Wed Sep 29 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-2jpp
- Make libgcj requirement less strict.

* Wed Sep 22 2004 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-1jpp
- Add a wrapper class so Ant's rmic task works.

* Fri Aug 20 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Fix argument to setup macro.

* Wed Jul 14 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Replace more macros in tool wrapper scripts.

* Tue Jul 13 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Install each tool individually.

* Tue Jul 13 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Bump gcc version to 3.4.1.

* Mon Jul  5 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Add javadoc javac slave.
- Add jni.h symlink.
- Create SDK include directory.

* Wed Jun 30 2004 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-1jpp
- Modify for FC3.

* Tue Jun 29 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Add java-1.4.2-gcj/Makefile to list of rpm-preprocessed files.

* Mon Jun 28 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Build and install tools.jar.  Depend on gcc 3.5.0.

* Tue May 25 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Initial build.
